
var callbacks = {};

var getParam = function(obj) {
    if (obj && typeof obj === 'object') {
        return JSON.stringify(obj);
    } else {
        return obj || '';
    }
};

var getPort = function() {
    return Math.floor(Math.random() * (1 << 30));
};

var JSBridge = {
    call: function(className, method, params) {
        var port = getPort();
        callbacks[port] = params;
        var uri = 'jsbridge://' + className + ':' + port + '/' + method + '?' + getParam(params);
        var result = window.prompt(uri, "");
        console.log(result)
    },
    onSuccess: function(port, jsonObj) {
        var callback = callbacks[port];
        callback && callback.success(jsonObj);
        delete callbacks[port];
    },
    onFail: function(port, jsonObj) {
        var callback = callbacks[port];
        callback && callback.fail(jsonObj);
        delete callbacks[port];
    },
};

JSBridge.onPayFinished = function(res) {
    alert(JSON.stringify(res))
};
var wx = {
    showToast: function(param) {
        JSBridge.call('NativeApi', 'showToast', param);
    },
    scanQRCode: function(param) {
        JSBridge.call('NativeApi', 'scanQRCode', param);
    },
    updateAppMessageShareData: function(param) {
        JSBridge.call('NativeApi', 'updateAppMessageShareData', param);
    },
    updateTimelineShareData: function(param) {
        JSBridge.call('NativeApi', 'updateTimelineShareData', param);
    },
    chooseImage: function(param) {
        JSBridge.call('NativeApi', 'chooseImage', param);
    },
    chooseVideo: function(param) {
        JSBridge.call('NativeApi', 'chooseVideo', param);
    },
    startRecord: function(param) {
        JSBridge.call('NativeApi', 'startRecord', param);
    },
    toPermission: function(param) {
        JSBridge.call('NativeApi', 'toPermission', param);
    },
    searchBluetooth: function(param) {
        JSBridge.call('NativeApi', 'searchBluetooth', param);
    },
    connectBluetooth: function(param) {
        JSBridge.call('NativeApi', 'connectBluetooth', param);
    },
    location: function(param) {
        JSBridge.call('NativeApi', 'location', param);
    },
    download: function(param) {
        JSBridge.call('NativeApi', 'download', param);
    },
};

var callAndroid = function() {
    console.log("执行callAndroid");
    wx.showToast({ 'msg': 'Hello JSBridge' }, function(res) {
        alert(JSON.stringify(res));
    });
};


//(function() {
//    if (window.WebViewJavascriptBridge) {
//        return;
//    }
//
//    var callbacks = {};
//
//    var getParam = function(obj) {
//        if (obj && typeof obj === 'object') {
//            return JSON.stringify(obj);
//        } else {
//            return obj || '';
//        }
//    };
//
//    var getPort = function() {
//        return Math.floor(Math.random() * (1 << 30));
//    };
//
//    var JSBridge = {
//        call: function(className, method, params, successCallback, failCallBack) {
//            var port = getPort();
//            callbacks[port] = [successCallback, failCallBack];
//            var uri = 'jsbridge://' + className + ':' + port + '/' + method + '?' + getParam(params);
//            var result = window.prompt(uri, "");
//            console.log(result)
//        },
//        onSuccess: function(port, jsonObj) {
//            var callback = callbacks[port];
//            callback && callback[0](jsonObj);
//            delete callbacks[port];
//        },
//        onFail: function(port, jsonObj) {
//            var callback = callbacks[port];
//            callback && callback[1](jsonObj);
//            delete callbacks[port];
//        },
//    };
//
//    JSBridge.onPayFinished = function(res) {
//        alert(JSON.stringify(res))
//    };
//
//
//
//        var wx = {
//            showToast: function(param) {
//                JSBridge.call('NativeApi', 'showToast', param, param.success, null);
//            },
//            scanQRCode: function(param) {
//                JSBridge.call('NativeApi', 'scanQRCode', param, param.success, param.fail);
//            },
//            updateAppMessageShareData: function(param) {
//                JSBridge.call('NativeApi', 'updateAppMessageShareData', param, param.success, param.fail);
//            },
//            updateTimelineShareData: function(param) {
//                JSBridge.call('NativeApi', 'updateTimelineShareData', param, param.success, param.fail);
//            },
//            chooseImage: function(param) {
//                JSBridge.call('NativeApi', 'chooseImage', param, param.success, param.fail);
//            },
//            chooseVideo: function(param) {
//                JSBridge.call('NativeApi', 'chooseVideo', param, param.success, param.fail);
//            },
//            startRecord: function(param) {
//                JSBridge.call('NativeApi', 'startRecord', param, param.success, param.fail);
//            },
//            toPermission: function(param) {
//                JSBridge.call('NativeApi', 'toPermission', param, param.success, param.fail);
//            },
//            searchBluetooth: function(param) {
//                JSBridge.call('NativeApi', 'searchBluetooth', param, param.success, param.fail);
//            },
//            connectBluetooth: function(param) {
//                JSBridge.call('NativeApi', 'connectBluetooth', param, param.success, param.fail);
//            },
//            location: function(param) {
//                JSBridge.call('NativeApi', 'location', param, param.success, param.fail);
//            },
//            download: function(param) {
//                JSBridge.call('NativeApi', 'download', param, param.success, param.fail);
//            },
//        };
//
//
//    var callAndroid = function() {
//        console.log("执行callAndroid");
//        wx.showToast({ 'msg': 'Hello JSBridge' }, function(res) {
//            alert(JSON.stringify(res));
//        });
//    };
//
//    var doc = document;
//    var readyEvent = doc.createEvent('Events');
//    var jobs = window.WVJBCallbacks || [];
//    readyEvent.initEvent('WebViewJavascriptBridgeReady');
//    readyEvent.bridge = wx;
//    window.WVJBCallbacks = []
//    jobs.forEach(function (job) {
//        job(wx)
//    })
//    doc.dispatchEvent(readyEvent);
//
//})();